#! /usr/bin/perl
# Script per els vols erronis devallats de lamarabunta.org

#use strict;
use LWP::Simple;
use warnings;
use encoding 'utf8';

@lin = ();

open (F, "./vols_0.txt");
binmode(F, ":utf8");

$i = 0;
while ($L = <F>) {  # Per a cada linia d'es fitxer
   chop($L);        # Llevam es salt de linia
   $lin[$i] = $L;   # Guardam sa linia
   $i++;
}

close (F);

print "Se han descargado $i registros\n";

open (F, ">./vols_1.txt");
binmode(F, ":utf8");

my $borr = 0;
my $modf = 0;
my $dupl = 0;
my $oldL ="";
#my $llar = 0;
foreach $L (@lin){
#   $llar = length($L)-length($oldL);
#   if ($llar < 0) {$llar = -$llar;}
   if ($L=~/ERRONEO/ && $L=~/16\/05\/2010/){
      $borr++;
   } elsif ($L=~/\t\t/ && ($L=~/24\/04\/2012/ || $L=~/07\/05\/2012/)){
      $borr++;
   } elsif ($L=~/\t\t/ && $L=~/12\/06\/2011/){
      $L =~ s/\t\t/\tLasius sp.\t/;
      $modf++;
      print F "$L\n";
   } elsif ($L=~/\t\t/ && $L=~/11\/08\/2009/){
      $L =~ s/\t\t/\tDesconocida\t/;
      $modf++;
      print F "$L\n";
   } elsif ($L=~/\t\t/ && $L=~/3\/09\/2010/){
      $L =~ s/\t\t/\t[Sin especificar]\t/;
      print F "$L\n";      
      $modf++;
   } elsif ($L=~/\t\t/ && $L=~/13\/08\/2008/){
      $L = "13/08/2008\tAphaenogaster iberica\tankxo\tNoroeste de Madrid\tMachos en piscina. Anunciado por Reurnal aquí [http://www.lamarabunta.org/viewtopic.php?t=12744]";
      $modf++;
      print F "$L\n";
   } elsif ($L eq $oldL){
      $dupl++;
      $borr++;
   } elsif ($L=~/abundnates/ && $L=~/30\/09\/2012/){
      $dupl++;
      $borr++;
   } elsif ($L=~/pheidole/ && $L=~/14\/06\/2004/){
      $dupl++;
      $borr++;
#   } elsif (hd($L, $oldL) <= 2) {
#      $a = hd($L, $oldL);
#      print "$llar, $a\n";
#      print "A --> $L\n";
#      print "B --> $oldL\n";
   } else {
      print F "$L\n";
   }
   $oldL = $L;
}

print "Se han borrado $borr registros, de los cuales $dupl eran duplicados.\n";
print "Se han modificado $modf registros\n";
$v=$i-$borr;
print "Registros válidos: $v\n";

close (F);


sub hd {
   #String length is assumed to be equal
   my ($k,$l) = @_;
   my $len1 = length ($k);
   my $len2 = length ($l);
   my $len = 0;
   my $num_mismatch = 0;
   if ($len1 > $len2){
      $len = $len2;
      $num_mismatch = $len1 - $len2;
   } else {
      $len = $len1;
      $num_mismatch = $len2 - $len1;
   }

   for (my $i=0; $i<$len; $i++){
      ++$num_mismatch if substr($k, $i, 1) ne substr($l, $i, 1);
   }

   return $num_mismatch;
}
