#! /usr/bin/perl
# Script per els vols erronis devallats de lamarabunta.org

#use strict;
use LWP::Simple;
use warnings;
use encoding 'utf8';

my @lin = ();

open (F, "./vols_2.txt");
binmode(F, ":utf8");

my $i = 0;
while ($L = <F>) {  # Per a cada linia d'es fitxer
   chop($L);        # Llevam es salt de linia
   $lin[$i] = $L;   # Guardam sa linia
   $i++;
}

close (F);

print "Se han identificado $i registros\n";

open (F, ">./vols_3.txt");
binmode(F, ":utf8");

my $j = 0;
my @t = ();
foreach (@lin){
   @t = split /\t/, $_;
   if (!$t[4]){$t[4]="";}  # Per si no han posat cap comentari
   if ($t[1]=~/Crematogaster auberti y Messor barbarus/){
      print F "$t[0]\tCrematogaster auberti\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole pallidula y Tetramorium sp./){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole pallidula y Lasius niger/){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor sp. y Aphaenogaster dulcineae/){
      print F "$t[0]\tMessor sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tAphaenogaster dulcineae\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Solenopsis sp., Messor barbarus y Aphaenogaster ibericus/){
      print F "$t[0]\tSolenopsis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tAphaenogaster ibericus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Tetramorium semilaeve, Cataglyphis ibericus/){
      print F "$t[0]\tTetramorium semilaeve\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCataglyphis ibericus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Formica pratensis, Lasius sp., Myrmica sp., Myrmica sp./){
      print F "$t[0]\tFormica pratensis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMyrmica sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Messor Barbarus y Bouvieri/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor bouvieri\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp y pheidole/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius grandis y Pheidole pallidula/){
      print F "$t[0]\tLasius grandis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp, Tetramorium sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus y Solenopsis sp./){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tSolenopsis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Aphaenogaster gibossa, Camponotus aethiops/){
      print F "$t[0]\tAphaenogaster gibbosa\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp. y Tetramorium sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor bouvieri y Messor barbarus/){
      print F "$t[0]\tMessor bouvieri\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole pallidula, Lasius sp./){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp. y Pheidole sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Camponotus cruentatus , Lasius niger/){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp \(niguer y grandis\), Pheidole y Tetramorium sp./){
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius grandis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Tetramorium, Lasius sp./){
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus\/ varias especies de crematogaster/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/C. scutellaris y Camp.lateralis/){
      print F "$t[0]\tCrematogaster scutellaris\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus lateralis\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Cataglyphis sp lasius sp tetramorium sp./){
      print F "$t[0]\tCataglyphis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Camponotus cruentatus, Camponotus aethiops/){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus y Aphaenogaster ibericus/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tAphaenogaster ibericus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius mixtus, Lasius niger, Lasius grandis, Lasius sp./){
      print F "$t[0]\tLasius mixtus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius grandis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Messor barbarus, kalotermes/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tKalotermes sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Camponotus cruentatus, Lasius niger, Camponotus aethiops/){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Solenopsis fugax,messor barbarus y crematogaster/){
      print F "$t[0]\tSolenopsis fugax\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Camponotus negra sp Tetramorium caespitum/){
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium caespitum\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole pallidula,Formica fusca/){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tFormica fusca\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole y lasius/){
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Tetramorium sp., T. semilaeve, Pheidole p. y Lasius niger/){
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium semilaeve\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Camponotus  y Myrmica sp./){
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMyrmica sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole Palliudla y Tetramorium so./){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp y Camponotus sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp , Pheidole pallidula , Tetramorium ,/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Formica dusmeti, cunicularia, subrufa, fusca/){
      print F "$t[0]\tFormica dusmeti\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tFormica cunicularia\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tFormica subrufa\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tFormica fusca\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Camponotus forelli y aethiops/){
      print F "$t[0]\tCamponotus foreli\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp. tetramorium sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Camponotus barbaricus y sp./){
      print F "$t[0]\tCamponotus barbaricus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius niger, Tetramorium sp, Myrmica ruginodis/){
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMyrmica ruginodis\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Lasius sp Pheidole pallidula/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Camponotus cruentatus, C. aethiops, Lasius, Tetramorium sp./){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Lasius niger, Pheidole pallidula, Camponotus cruentatus/){
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Tetramorium semilaeve. Camponotus cruentatus y athiops/){
      print F "$t[0]\tTetramorium semilaeve\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Lasius sp., Formica rufibarbis y Tapinoma nigerrimum/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tFormica rufibarbis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTapinoma nigerrimum\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Messor marocanus Y Messor bouvieri/){
      print F "$t[0]\tMessor marocanus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor bouvieri\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus\/ solenopsis/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tSolenopsis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Cataglyphis sp y formica pratensis/){
      print F "$t[0]\tCataglyphis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tFormica pratensis\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole pallidula y varias especies de Tetramorium./){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius y Tetramorium sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Formica ¿sanguinea\?, Lasius sp alada, Camponotus sp./){
      print F "$t[0]\tFormica sanguinea\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Lasius flavus y Crematogaster scutellaris/){
      print F "$t[0]\tLasius flavus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster scutellaris\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp, Pheidole pallidula/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus\/messor estructor/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor structor\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole y Tetramorium sp./){
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius grandis; Pheidole sp./){
      print F "$t[0]\tLasius grandis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius flavus \/ Hypoponera eduardi/){
      print F "$t[0]\tLasius flavus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tHypoponera eduardi\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Solenopsis sp \/ Myrmica specioides/){
      print F "$t[0]\tSolenopsis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMyrmica specioides\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus, Solenopsis sp./){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tSolenopsis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Camponotus sp,Pheidole sp,Lasius sp./){
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Lasius sp. Tetramorium sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius niger,Pheidole pallidula/){
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Camponotus cruentatus, C. aethiops, Lasius sp, Pheidole sp./){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/A.gibbosa, C.cruentatus, C.aethiops, P.palidulla, Lasius sp./){
      print F "$t[0]\tAphaenogaster gibbosa\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=5;
   } elsif ($t[1]=~/Lasius sp, pheidole pallidua, tetramorium sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Lasius y myrmica/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMyrmica sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius, pheidole, tetramorum y posible camponotus/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Messor sp. Crematogaster auberti y Aphaenogaster sp./){
      print F "$t[0]\tMessor sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster auberti\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tAphaenogaster sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Formica posiblemente \(subrufa\) y Pheidole palidulla/){
      print F "$t[0]\tFormica subrufa\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus, Lasius sp./){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Camponotus cruentatus y Camponotus aethiops/){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius grandis, Pheidole pallidula y Tetramorium sp./){
      print F "$t[0]\tLasius grandis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramoriumsp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Messor barbarus Crematogaster auberti Aphaenogaster dulcineae/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster auberti\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tAphaenogaster dulcineae\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Cataglyphis y Camponotus cruentatus/){
      print F "$t[0]\tCataglyphis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor, cremas, etc/){
      print F "$t[0]\tMessor sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius grandis y pheidoles/){
      print F "$t[0]\tLasius grandis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius ¿Niger\? Tetramorium sp./){
      print F "$t[0]\tLasius niger\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp. Pheidole pallidula y Tetramorium sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Messor barbarus y bouvieri/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMessor bouvieri\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus y Crematogaster scutellaris/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster scutellaris\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole pallidula, camponotus sylvaticus/){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sylvaticus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Aphaenogaster senilis y Plagiolepis pygmaea/){
      print F "$t[0]\tAphaenogaster senilis\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPlagiolepis pygmaea\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius umbratus \(Chthonolasius\) y Myrmica sp./){
      print F "$t[0]\tLasius umbratus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMyrmica sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp tetra sp pps camponotus negra sin identif/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Camponotus cruentatus, C. aethiops, P.pallidula, Lasius sp./){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus aethiops\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Camponotus cruentatus, Pheidole pallidula/){
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp y tetramorium sp en masa/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Tetramorium sp y Camponotus sp./){
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Tetramorium sp. y Camponotus sp./){
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp, Tetramorium forte, Tetramorium caespitum, Pheidol/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium forte\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium caespitum\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Lasius y Pheidole y Tetras/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Camponotus truncatus, cruentatus Lasius sp, Aphaenogaster sp./){
      print F "$t[0]\tCamponotus truncatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tAphaenogaster sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=4;
   } elsif ($t[1]=~/Pheidole pallidula, Tetramorium Semilaeve/){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium semilaeve\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius, tetramorium, Myrmica sp./){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tMyrmica sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Myrmica sp. Formica lugubris/){
      print F "$t[0]\tMyrmica sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tFormica lugubris\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus, Aphaenogaster sp\(dulcinae posiblemente\)/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tAphaenogaster dulcineae\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus y Crematogaster auberti/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCrematogaster auberti\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Lasius sp. Pheidole pallidula y Plagiolepis pygmaea/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPlagiolepis pygmaea\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Lasius y camponotus cruentatus/){
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus cruentatus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Tetramorium forte y Tetramorium sp./){
      print F "$t[0]\tTetramorium forte\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor barbarus, solenopsis/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tSolenopsis sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Pheidole pallidula, Temnothorax sp., Campontus truncatus./){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTemnothorax sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus truncatus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Pheidole pallidula y tetramorium sp./){
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Formica sanguinea\/ tetramorium sp./){
      print F "$t[0]\tFormica sanguinea\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Messor Barbarus y Pheidole pallidula/){
      print F "$t[0]\tMessor barbarus\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tPheidole pallidula\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } elsif ($t[1]=~/Formica, Tetramorium y Lasius sp./){
      print F "$t[0]\tFormica sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tTetramorium sp.\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tLasius sp.\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=3;
   } elsif ($t[1]=~/Camponotus foreli y Camponotus sylvaticus/){
      print F "$t[0]\tCamponotus foreli\t$t[2]\t$t[3]\t$t[4]\n";
      print F "$t[0]\tCamponotus sylvaticus\t$t[2]\t$t[3]\t$t[4]\n";
      $j+=2;
   } else {
      print F "$_\n";
      $j++;
   }
}

my $k = $j-$i;
print "Se han añadido $k registros producto de separar avistamientos múltiples.\n";
print "Avistamientos actuales totales: $j\n";

close (F);

